From mboxrd@z Thu Jan  1 00:00:00 1970
Date: Tue, 22 Aug 2023 06:51:48 +0200
From: "Peter J. Philipp" <pjp@delphinusdns.org>
To: list+catgirl@causal.agency
Subject: too many times have I accidentally pressed control-c in the wrong
 term!
Message-ID: <ZOQ+5DOrULQfDa2D@stern.delphinusdns.org>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline

Hi JuneBug!

diff --git a/chat.c b/chat.c
index 8c425d4..79ef097 100644
--- a/chat.c
+++ b/chat.c
@@ -97,6 +97,7 @@ static void exitSave(void) {
 	}
 }
 
+time_t lastsigint = 0;
 uint execID;
 int execPipe[2] = { -1, -1 };
 int utilPipe[2] = { -1, -1 };
@@ -239,6 +240,7 @@ int main(int argc, char *argv[]) {
 	char *pass = NULL;
 	const char *user = NULL;
 	const char *real = NULL;
+	time_t now;
 
 	struct option options[] = {
 		{ .val = '!', .name = "insecure", no_argument },
@@ -447,7 +449,20 @@ int main(int argc, char *argv[]) {
 		}
 
 		if (signals[SIGHUP]) self.quit = "zzz";
-		if (signals[SIGINT] || signals[SIGTERM]) break;
+		if (signals[SIGINT]) {
+			now = time(NULL);
+			if (difftime(now, lastsigint) <= 1.0)
+				break;
+			else
+				uiFormat(
+					Network, Warm, NULL,
+					"SIGINT (^C) registewed only if you "
+					"pwess me again within one second"
+					);
+				
+			lastsigint = now;
+		}
+		if (signals[SIGTERM]) break;
 
 		if (nfds > 0 && fds[1].revents) {
 			ping = false;



I tested this, it seems to work.  Thanks for catgirl!

-peter

-- 
Over thirty years experience on Unix-like Operating Systems starting with QNX.

